searchData={"items":[{"type":"module","title":"RabbitMQStream.OsirisChunk","doc":"Struct that holds the data of a Osiris chunk, which is the format used by RabbitMQ Stream to store the stream data.\n\n  You can find more information at their [Github repo](https://github.com/rabbitmq/osiris)","ref":"RabbitMQStream.OsirisChunk.html"},{"type":"function","title":"RabbitMQStream.OsirisChunk.decode_messages!/2","doc":"","ref":"RabbitMQStream.OsirisChunk.html#decode_messages!/2"},{"type":"type","title":"RabbitMQStream.OsirisChunk.chunk_type/0","doc":"","ref":"RabbitMQStream.OsirisChunk.html#t:chunk_type/0"},{"type":"type","title":"RabbitMQStream.OsirisChunk.t/0","doc":"","ref":"RabbitMQStream.OsirisChunk.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Connection","doc":"Responsible for encoding and decoding messages, opening and maintaining a socket connection to a single node.\nIt connects to the RabbitMQ, and authenticates, and mantains the connection open with heartbeats.\n\n# Adding a connectiong to the supervision tree\n\nYou can define a connection with:\n\n    defmodule MyApp.MyConnection\n      use RabbitMQStream.Connection\n    end\n\n\nThen you can add it to your supervision tree:\n\n    def start(_, _) do\n      children = [\n        {MyApp.MyConnection, username: \"guest\", password: \"guest\", host: \"localhost\", vhost: \"/\"},\n        # ...\n      ]\n\n      opts = # ...\n      Supervisor.start_link(children, opts)\n    end\n\n\n# Connection configuration\nThe connection accept the following options:\n\n* `username` - The username to use for authentication. Defaults to `guest`.\n* `password` - The password to use for authentication. Defaults to `guest`.\n* `host` - The host to connect to. Defaults to `localhost`.\n* `port` - The port to connect to. Defaults to `5552`.\n* `vhost` - The virtual host to use. Defaults to `/`.\n* `frame_max` - The maximum frame size in Bytes. Defaults to `1_048_576`.\n* `heartbeat` - The heartbeat interval in seconds. Defaults to `60`.\n* `lazy` - If `true`, the connection won't starting until explicitly calling `connect/1`. Defaults to `false`.\n\n\n# Consuming messages\nYou can consume messages by calling `subscribe/5`:\n\n    {:ok, _subscription_id} = MyApp.MyConnection.subscribe(\"stream-01\", self(), :next, 999)\n\n\n\n# Configuration\nThe configuration for the connection can be set in your `config.exs` file:\n\n    config :rabbitmq_stream, MyApp.MyConnection,\n      username: \"guest\",\n      password: \"guest\"\n      # ...\n\nYou can override each configuration option by manually passing each configuration on the `use` macro:\n\n    defmodule MyApp.MyConnection\n      use RabbitMQStream.Connection, username: \"guest\", password: \"guest\"\n    end\n\nor when adding to the supervision tree:\n\n    def start(_, _) do\n      children = [\n        {MyApp.MyConnection, username: \"guest\", password: \"guest\"},\n        # ...\n      ]\n\n      opts = # ...\n      Supervisor.start_link(children, opts)\n    end\n\nThe precedence order is is the same order as the examples above, from top to bottom.","ref":"RabbitMQStream.Connection.html"},{"type":"module","title":"Startup - RabbitMQStream.Connection","doc":"Any call or cast to the connection while it is not connected will be buffered and executed once the connection is open.","ref":"RabbitMQStream.Connection.html#module-startup"},{"type":"function","title":"RabbitMQStream.Connection.child_spec/1","doc":"","ref":"RabbitMQStream.Connection.html#child_spec/1"},{"type":"function","title":"RabbitMQStream.Connection.close/3","doc":"Sends a 'close' command to the RabbitMQ Stream server, and waits for the\nresponse, before calling the 'close/1' callback on the transport.","ref":"RabbitMQStream.Connection.html#close/3"},{"type":"function","title":"RabbitMQStream.Connection.connect/1","doc":"Starts the connection process with the RabbitMQ Stream server, and waits\nuntil the authentication is complete.\n\nIf the authentication process has already been started by other process,\nthis call waits for it to complete before return the result.","ref":"RabbitMQStream.Connection.html#connect/1"},{"type":"function","title":"RabbitMQStream.Connection.create_stream/3","doc":"Creates a stream with the given `stream_name`. Returns an error when\nthe stream already exists.","ref":"RabbitMQStream.Connection.html#create_stream/3"},{"type":"function","title":"RabbitMQStream.Connection.create_super_stream/4","doc":"Creates a Super Stream, with the specified partitions. The partitions is a Keyword list,\nwhere each key is the partition name, and the value is the routing key.\n\nWhen publishing a message through a RabbitMQStream.SuperProducer, you can implement the\nthe `routing_key/2` callback to define the routing key for each message.\n\nRequires RabbitMQ 3.13.0 or later.\n\nExample:\n    RabbitMQStream.Connection.create_super_stream(conn, \"transactions\",\n      \"route-A\": [\"stream-01\", \"stream-02\"],\n      \"route-B\": [\"stream-03\", \"stream-04\"]\n    )","ref":"RabbitMQStream.Connection.html#create_super_stream/4"},{"type":"function","title":"RabbitMQStream.Connection.credit/3","doc":"Adds the specified amount of credits to the subscription under the given `subscription_id`.\n\nThis function always returns `:ok` as the RabbitMQ Server only sends a response if the command fails,\nwhich only happens if the subscription is not found. In that case the error is logged.","ref":"RabbitMQStream.Connection.html#credit/3"},{"type":"function","title":"RabbitMQStream.Connection.declare_producer/3","doc":"Declares a producer on the stream with the `producer_reference` key.\n\nRabbitMQ expects a producer to be declare to prevent message duplication,\nby tracking the `sequence` number, which must be sent with each message.c\n\nYou can use the `query_producer_sequence/3` the query a producer's sequence\nnumber tracked by the server.\n\nIt returns an id that identifies this producer. This id is only valid for this\nconnection, as other connections might have the same id for different\nproducers.","ref":"RabbitMQStream.Connection.html#declare_producer/3"},{"type":"function","title":"RabbitMQStream.Connection.delete_producer/2","doc":"Unregisters the producer, under the provided id, from the server.","ref":"RabbitMQStream.Connection.html#delete_producer/2"},{"type":"function","title":"RabbitMQStream.Connection.delete_stream/2","doc":"Deletes the stream with the given `stream_name`. Returns an error when\nthe stream doesn't exist.","ref":"RabbitMQStream.Connection.html#delete_stream/2"},{"type":"function","title":"RabbitMQStream.Connection.delete_super_stream/2","doc":"Deletes a Super Stream.\n\nRequires RabbitMQ 3.13.0 or later.","ref":"RabbitMQStream.Connection.html#delete_super_stream/2"},{"type":"function","title":"RabbitMQStream.Connection.partitions/2","doc":"Lists all the partitions of a super stream.\n\nRequires RabbitMQ 3.13.0 or later.","ref":"RabbitMQStream.Connection.html#partitions/2"},{"type":"function","title":"RabbitMQStream.Connection.publish/5","doc":"Sends a message to the stream referenced by the provided 'producer_id'.\n\nThe 'publishing_id' must be unique for the given producer, or the message\nwill be ignored/dropped by the server.\n\nStarting at 3.13.x, you can optionally provide a 'filter_value' parameter,\nwhich is used by the server to filter the messages to be sent to a consumer\nthat have provided a 'filter' parameter.","ref":"RabbitMQStream.Connection.html#publish/5"},{"type":"function","title":"RabbitMQStream.Connection.query_metadata/2","doc":"Queries the metadata for the provided streams, along side with a\nlisting of all the brokers available in the cluster.\n\nIf a stream doesn't exist, it stills returns an entry for it, but\nwith a `:stream_does_not_exist` code.","ref":"RabbitMQStream.Connection.html#query_metadata/2"},{"type":"function","title":"RabbitMQStream.Connection.query_offset/3","doc":"Queries the offset for the given `stream_name` under `offset_reference`.","ref":"RabbitMQStream.Connection.html#query_offset/3"},{"type":"function","title":"RabbitMQStream.Connection.query_producer_sequence/3","doc":"Queries the sequence number for the `producer_reference`, on the specified\n`stream_name`.\n\nAll messages sent to the server must have a distinct sequence number, which\nis tracked by the server.","ref":"RabbitMQStream.Connection.html#query_producer_sequence/3"},{"type":"function","title":"RabbitMQStream.Connection.respond/3","doc":"The server will sometimes send a request to the client, which we must send a response to.\n\nAnd example request is the 'ConsumerUpdate', where the server expects a response with the\noffset. So the connection sends the request to the subscription handler, which then calls\nthis function to send the response back to the server.","ref":"RabbitMQStream.Connection.html#respond/3"},{"type":"function","title":"RabbitMQStream.Connection.route/3","doc":"Lists the names of all the streams of super stream, under the given `routing_key`.\n\nRequires RabbitMQ 3.13.0 or later.","ref":"RabbitMQStream.Connection.html#route/3"},{"type":"function","title":"RabbitMQStream.Connection.start_link/1","doc":"","ref":"RabbitMQStream.Connection.html#start_link/1"},{"type":"function","title":"RabbitMQStream.Connection.store_offset/4","doc":"Stores an `offset` on the given `stream_name` under `offset_reference`.\n\nThis appends an `offset` to the stream, which can be retrieved later using\nwith `query_offset/3`, by providing the same `offset_reference`.","ref":"RabbitMQStream.Connection.html#store_offset/4"},{"type":"function","title":"RabbitMQStream.Connection.stream_stats/2","doc":"Queries the metadata information about a stream.","ref":"RabbitMQStream.Connection.html#stream_stats/2"},{"type":"function","title":"RabbitMQStream.Connection.subscribe/6","doc":"Starts consuming messages from the server, starting at the provided 'offset'.\n\nThe connection wills start send the messages to the provided 'pid' with the\nfollowing format:\n\n    def handle_info({:deliver, %RabbitMQStream.Message.Types.DeliverData{}}, _) do\n      # ...\n    end\n\nYou can optionally provide properties when declaring the subscription. The\navaiable options are the following:\n\n* `:single_active_consumer`: set to `true` to enable [single active consumer](https://blog.rabbitmq.com/posts/2022/07/rabbitmq-3-11-feature-preview-single-active-consumer-for-streams/) for this subscription.\n* `:super_stream`: set to the name of the super stream the subscribed is a partition of.\n* `:filter`: List of strings that define the value of the filter_key to match.\n* `:match_unfiltered`: whether to return messages without any filter value or not.\n\nBe aware that a filter value is registered per message, and the server uses a Bloom\nFilter to check if a chunk has messages that match a filter. But this filter might\ngive false positives, and not all the messages of a chunk might match the filter.\nSo additional filtering on by the User might be necessary.","ref":"RabbitMQStream.Connection.html#subscribe/6"},{"type":"function","title":"RabbitMQStream.Connection.supports?/3","doc":"Checks if the connected server supports the given command.","ref":"RabbitMQStream.Connection.html#supports?/3"},{"type":"function","title":"RabbitMQStream.Connection.unsubscribe/2","doc":"Unregisters a consumer from the connection.","ref":"RabbitMQStream.Connection.html#unsubscribe/2"},{"type":"type","title":"RabbitMQStream.Connection.connection_option/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_option/0"},{"type":"type","title":"RabbitMQStream.Connection.connection_options/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_options/0"},{"type":"type","title":"RabbitMQStream.Connection.offset/0","doc":"","ref":"RabbitMQStream.Connection.html#t:offset/0"},{"type":"type","title":"RabbitMQStream.Connection.t/0","doc":"","ref":"RabbitMQStream.Connection.html#t:t/0"},{"type":"behaviour","title":"RabbitMQStream.Connection.Behavior","doc":"Defines the interface a Connection Module that interacts with the Streams Protocol TCP/TLS API.","ref":"RabbitMQStream.Connection.Behavior.html"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.close/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:close/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.connect/1","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:connect/1"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.create_stream/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:create_stream/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.create_super_stream/4","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:create_super_stream/4"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.credit/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:credit/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.declare_producer/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:declare_producer/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.delete_producer/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:delete_producer/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.delete_stream/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:delete_stream/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.delete_super_stream/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:delete_super_stream/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.partitions/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:partitions/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.publish/5","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:publish/5"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.query_metadata/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:query_metadata/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.query_offset/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:query_offset/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.query_producer_sequence/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:query_producer_sequence/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.respond/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:respond/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.route/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:route/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.store_offset/4","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:store_offset/4"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.stream_stats/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:stream_stats/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.subscribe/6","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:subscribe/6"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.supports?/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:supports?/2"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.supports?/3","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:supports?/3"},{"type":"callback","title":"RabbitMQStream.Connection.Behavior.unsubscribe/2","doc":"","ref":"RabbitMQStream.Connection.Behavior.html#c:unsubscribe/2"},{"type":"behaviour","title":"RabbitMQStream.Consumer","doc":"Used to declare a Persistent Consumer module. It is able to process\nchunks by implementing the `handle_chunk/1` or `handle_chunk/2` callbacks.\n\n# Usage\n\n    defmodule MyApp.MyConsumer do\n      use RabbitMQStream.Consumer,\n        connection: MyApp.MyConnection,\n        stream_name: \"my_stream\",\n        initial_offset: :first\n\n      @impl true\n      def handle_chunk(%RabbitMQStream.OsirisChunk{} = _chunk, _consumer) do\n        :ok\n      end\n    end\n\n\n# Parameters\n\n* `:connection` - The connection module to use. This is required.\n* `:stream_name` - The name of the stream to consume. This is required.\n* `:initial_offset` - The initial offset. This is required.\n* `:initial_credit` - The initial credit to request from the server. Defaults to `50_000`.\n* `:offset_tracking` - Offset tracking strategies to use. Defaults to `[count: [store_after: 50]]`.\n* `:flow_control` - Flow control strategy to use. Defaults to `[count: [credit_after: {:count, 1}]]`.\n* `:offset_reference` -\n* `:private` - Private data that can hold any value, and is passed to the `handle_chunk/2` callback.\n* `:serializer` - The module to use to decode the message. Defaults to `__MODULE__`,\n  which means that the consumer will use the `decode!/1` callback to decode the message, which is implemented by default to return the message as is.\n\n* `:properties` - Define the properties of the subscription. Can only have one option at a time.\n  * `:single_active_consumer`: set to `true` to enable [single active consumer](https://blog.rabbitmq.com/posts/2022/07/rabbitmq-3-11-feature-preview-single-active-consumer-for-streams/) for this subscription.\n  * `:super_stream`: set to the name of the super stream the subscribed is a partition of.\n  * `:filter`: List of strings that define the value of the filter_key to match.\n  * `:match_unfiltered`: whether to return messages without any filter value or not.\n\n\n# Offset Tracking\n\nThe consumer is able to track its progress in the stream by storing its\nlatests offset in the stream. Check [Offset Tracking with RabbitMQ Streams(https://blog.rabbitmq.com/posts/2021/09/rabbitmq-streams-offset-tracking/) for more information on\nhow offset tracking works.\n\nThe consumer can be configured to use different offset tracking strategies,\nwhich decide when to store the offset in the stream. You can implement your\nown strategy by implementing the `RabbitMQStream.Consumer.OffsetTracking`\nbehaviour, and passing it to the `:offset_tracking` option. It defaults to\n`RabbitMQStream.Consumer.OffsetTracking.CountStrategy`, which stores the\noffset after, by default, every 50_000 messages.\n\n# Flow Control\n\nThe RabbitMQ Streams server requires that the consumer declares how many\nmessages it is able to process at a time. This is done by informing an amount\nof 'credits' to the server. After every chunk is sent, one credit is consumed,\nand the server will send messages only if there are credits available.\n\nWe can configure the consumer to automatically request more credits based on\na strategy. By default it uses the `RabbitMQStream.Consumer.FlowControl.MessageCount`,\nwhich requests 1 additional credit for every 1 processed chunk. Please check\nthe RabbitMQStream.Consumer.FlowControl.MessageCount module for more information.\n\nYou can also call `RabbitMQStream.Consumer.credit/2` to manually add more\ncredits to the subscription, or implement your own strategy by implementing\nthe `RabbitMQStream.Consumer.FlowControl` behaviour, and passing\nit to the `:flow_control` option.\n\nYou can find more information on the [RabbitMQ Streams documentation](https://www.rabbitmq.com/stream.html#flow-control).\n\nIf you want an external process to be fully in control of the flow control\nof a consumer, you can set the `:flow_control` option to `false`. Then\nyou can call `RabbitMQStream.Consumer.credit/2` to manually add more\ncredits to the subscription.","ref":"RabbitMQStream.Consumer.html"},{"type":"behaviour","title":"Commited Offset - RabbitMQStream.Consumer","doc":"As of RabbitMQ 3.13, each deliver message now has the `commited_offset`. This respresents the 'next' offset, instead of the 'last'.\n\nBefore 3.13, using the next offset meant that the tracking was always \"off by one\", meaning that everytime a Consumer started, it would\nit would always receive the last message it read once again.\n\nAs of 3.13 and forward, the tracking now prefers to use the `commited_offset` when storing it to the stream, meaning that if it has received a message\nand then the offset is stored, it would not receive it again.\n\n\n# Configuration\n\nYou can configure each consumer with:\n\n    config :rabbitmq_stream, MyApp.MyConsumer,\n      connection: MyApp.MyConnection,\n      stream_name: \"my_stream\",\n      initial_offset: :first,\n      initial_credit: 50_000,\n      offset_tracking: [count: [store_after: 50]],\n      flow_control: [count: [credit_after: {:count, 1}]],\n      serializer: Jason\n\nThese options are overriden by the options passed to the `use` macro, which\nare overriden by the options passed to `start_link/1`.\n\nAnd also you can override the defaults of all consumers with:\n\n      config :rabbitmq_stream, :defaults,\n        consumer: [\n          connection: MyApp.MyConnection,\n          initial_credit: 50_000,\n          # ...\n        ],\n\nGlobally configuring all consumers ignores the following options:\n\n* `:stream_name`\n* `:offset_reference`\n* `:private`\n\n# Decoding\n\nYou can declare a function for decoding each message by declaring a `decode!/1` callback as follows:\n    defmodule MyApp.MyConsumer do\n      use RabbitMQStream.Consumer,\n        connection: MyApp.MyConnection,\n        stream_name: \"my_stream\",\n        initial_offset: :first\n\n      @impl true\n      def decode!(message) do\n        Jason.decode!(message)\n      end\n    end\n\nOr by passing a `:serializer` option to the `use` macro:\n    defmodule MyApp.MyConsumer do\n      use RabbitMQStream.Consumer,\n        connection: MyApp.MyConnection,\n        stream_name: \"my_stream\",\n        initial_offset: :first,\n        serializer: Jason\n    end\n\nThe default value for the `:serializer` is the module itself, unless a default is defined at a higher level of the\nconfiguration. If there is a `decode!/1` callback defined, it is always used\n\n\n# Properties\nYou can provide additional properties to the consumer to change its behavior, by passing `:properties`.","ref":"RabbitMQStream.Consumer.html#module-commited-offset"},{"type":"behaviour","title":"Single active consumer - RabbitMQStream.Consumer","doc":"To use it, you must provide a \"group_name\". The server manages each consumer so the only one will of each group\nwill be receiving chunks at a time.\n\nAlthough there is only one Consumer active, we must provide the server the offset a consumer starts on when being upgraded\nto the being the active one. To do so you must implement the `handle_update/2` callback, which must return a `{:ok, offset}` tuple.\n\n    @impl true\n    def handle_update(_, :upgrade) do\n      {:ok, :last}\n    end\n\n    @impl true\n    def handle_update(_, :downgrade) do\n      # Must return something when being downgraded, but it is not used by the server.\n      # Could be useful to use some external logic to persist the offset somewhere,\n      #  so that it can be queried by the other consumer that is being upgraded\n      {:ok, :last}\n    end","ref":"RabbitMQStream.Consumer.html#module-single-active-consumer"},{"type":"callback","title":"RabbitMQStream.Consumer.before_start/2","doc":"Callback invoked right before subscribing a consumer to the stream.\nMight be usefull for setup logic, like creating a stream if it doesn't yet exists.","ref":"RabbitMQStream.Consumer.html#c:before_start/2"},{"type":"function","title":"RabbitMQStream.Consumer.child_spec/1","doc":"","ref":"RabbitMQStream.Consumer.html#child_spec/1"},{"type":"callback","title":"RabbitMQStream.Consumer.credit/1","doc":"Send a command to add the provided amount of credits to the consumer.\n\nThe credits are tracked by the Server, but it is also stored internally\non the Consumer state, which then can be retreived by calling 'get_credits/0'.\n\nAlways returns :ok, and any errors when adding credits to a consumer are logged.","ref":"RabbitMQStream.Consumer.html#c:credit/1"},{"type":"callback","title":"RabbitMQStream.Consumer.decode!/1","doc":"Callback invoked on each message inside of a chunk.\n\nIt can be used to decode the message from a binary format into a Map,\nor to use GZIP to decompress the content.\n\nYou can also globally define a 'Serializer' module, that must implement\nthe 'decode!/1' callback, at compile-time configuration so it is added\nto as the default callback.","ref":"RabbitMQStream.Consumer.html#c:decode!/1"},{"type":"callback","title":"RabbitMQStream.Consumer.get_credits/0","doc":"Returns the internally tracked amount of credits for the Consumer.","ref":"RabbitMQStream.Consumer.html#c:get_credits/0"},{"type":"callback","title":"RabbitMQStream.Consumer.handle_chunk/1","doc":"The callback that is invoked when a chunk is received.\n\nEach chunk contains a list of potentially many data entries, along with\nmetadata about the chunk itself. The callback is invoked once for each\nchunk received.\n\nOptionally if you implement `handle_chunk/2`, it also passes the current\nstate of the consumer. It can be used to access the `private` field\npassed to `start_link/1`, and other fields.\n\nThe return value is ignored.","ref":"RabbitMQStream.Consumer.html#c:handle_chunk/1"},{"type":"callback","title":"RabbitMQStream.Consumer.handle_chunk/2","doc":"","ref":"RabbitMQStream.Consumer.html#c:handle_chunk/2"},{"type":"callback","title":"RabbitMQStream.Consumer.handle_update/2","doc":"If the consumer has been defined with the 'single-active-consumer' parameter,\nthis callback is invoked when the consumer is being upgraded to being the\nactive one, or when downgraded to being an inactive one.\n\nWhen the flag parameter is set to ':upgrade', it means that the consumer is being\nupgraded to active and it must return the offset for where it wants to start\nconsuming from the stream.\n\nWhen being downgraded, the offset returned by the callback is also sent\nto the server but, at the moment, is not being used in any way, and is only\nsent because the API requires. But this is actually a good moment to store\nthe offset so that it can be retrieved by the other consumer that is being\nupgraded.","ref":"RabbitMQStream.Consumer.html#c:handle_update/2"},{"type":"function","title":"RabbitMQStream.Consumer.start_link/1","doc":"","ref":"RabbitMQStream.Consumer.html#start_link/1"},{"type":"callback","title":"RabbitMQStream.Consumer.store_offset/0","doc":"Persists the consumer's latests offset into the stream.\n\nBe aware that it does not reset any tracking strategy.","ref":"RabbitMQStream.Consumer.html#c:store_offset/0"},{"type":"type","title":"RabbitMQStream.Consumer.option/0","doc":"","ref":"RabbitMQStream.Consumer.html#t:option/0"},{"type":"type","title":"RabbitMQStream.Consumer.opts/0","doc":"","ref":"RabbitMQStream.Consumer.html#t:opts/0"},{"type":"type","title":"RabbitMQStream.Consumer.t/0","doc":"","ref":"RabbitMQStream.Consumer.html#t:t/0"},{"type":"behaviour","title":"RabbitMQStream.Producer","doc":"`RabbitMQStream.Producer` allows you to define modules or processes that publish messages to a single stream.\n\n# Defining a producer Module\n\nA standalone producer module can be defined with:\n\n    defmodule MyApp.MyProducer do\n      use RabbitMQStream.Producer,\n        stream_name: \"my-stream\",\n        connection: MyApp.MyConnection\n    end\n\nAfter adding it to your supervision tree, you can publish messages with:\n\n    MyApp.MyProducer.publish(\"Hello, world!\")\n\nYou can add the producer to your supervision tree as follows this:\n\n    def start(_, _) do\n      children = [\n        # ...\n        MyApp.MyProducer\n      ]\n\n      opts = # ...\n      Supervisor.start_link(children, opts)\n    end\n\nThe standalone producer starts its own `RabbitMQStream.Connection`, declaring itself and fetching its most recent `publishing_id`, and declaring the stream, if it does not exist.\n\n# Configuration\nThe RabbitMQStream.Producer accepts the following options:\n\n* `:stream_name` - The name of the stream to publish to. Required.\n* `:reference_name` - The string which is used by the server to prevent [Duplicate Message](https://blog.rabbitmq.com/posts/2021/07/rabbitmq-streams-message-deduplication/). Defaults to `__MODULE__.Producer`.\n* `:connection` - The identifier for a `RabbitMQStream.Connection`.\n* `:serializer` - The module to use to decode the message. Defaults to `nil`, which means no encoding is done.\n\nYou can also declare the configuration in your `config.exs`:\n\n    config :rabbitmq_stream, MyApp.MyProducer,\n      stream_name: \"my-stream\",\n      connection: MyApp.MyConnection\n\n\n# Setting up\n\nYou can optionally define a `before_start/2` callback to perform setup logic, such as creating the stream, if it doesn't yet exists.\n\n    defmodule MyApp.MyProducer do\n      use RabbitMQStream.Producer,\n        stream_name: \"my-stream\",\n        connection: MyApp.MyConnection\n\n      @impl true\n      def before_start(_opts, state) do\n        # Create the stream\n        RabbitMQStream.Connection.create_stream(state.connection, state.stream_name)\n\n        state\n      end\n    end\n\n# Configuration\n\nYou can configure each Producer with:\n\n    config :rabbitmq_stream, MyApp.MyProducer,\n      stream_name: \"my-stream\",\n      connection: MyApp.MyConnection\n\nAnd also you can override the defaults of all producers with:\n\n      config :rabbitmq_stream, :defaults,\n        producer: [\n          connection: MyApp.MyConnection,\n          # ...\n        ]\n        serializer: Jason\n\nGlobally configuring all producers ignores the following options:\n\n* `:stream_name`\n* `:reference_name`\n\n\n# Encoding\n\nYou can declare a function for encoding each message by declaring a `encode!/1` callback as follows:alarm_handler\n    defmodule MyApp.MyProducer do\n      use RabbitMQStream.Producer,\n        stream_name: \"my-stream\",\n        connection: MyApp.MyConnection\n\n      @impl true\n      def encode!(message) do\n        Jason.encode!(message)\n      end\n    end\n\nOr by passing a `:serializer` option to the `use` macro:\n    defmodule MyApp.MyProducer do\n      use RabbitMQStream.Producer,\n        stream_name: \"my-stream\",\n        connection: MyApp.MyConnection,\n        serializer: Jason\n    end\n\nThe default value for the `:serializer` is the module itself, unless a default is defined at a higher level of the\nconfiguration. If there is a `encode!/1` callback defined, it is always used","ref":"RabbitMQStream.Producer.html"},{"type":"callback","title":"RabbitMQStream.Producer.before_start/2","doc":"Optional callback that is called after the process has started, but before the\nproducer has declared itself and fetched its most recent `publishing_id`.\n\nThis is usefull for setup logic, such as creating the Stream if it doesn't yet exists.","ref":"RabbitMQStream.Producer.html#c:before_start/2"},{"type":"function","title":"RabbitMQStream.Producer.child_spec/1","doc":"","ref":"RabbitMQStream.Producer.html#child_spec/1"},{"type":"callback","title":"RabbitMQStream.Producer.encode!/1","doc":"Callback responsible for encoding a message into binary format.\n\nIt can be used in many ways, such as to 'Jason.encode!/1' a Map,\nor to Gzip Compact a message before it is appended to the Stream.","ref":"RabbitMQStream.Producer.html#c:encode!/1"},{"type":"callback","title":"RabbitMQStream.Producer.filter_value/1","doc":"Callback responsible for generating the 'filter_value' for a message. The value\nis used by the Server for filtering the chunks sent to consumer that have defined\na 'filter' parameter.\n\nThe callback is invoked before the message is encoded, by the serializer options.\n\nExample defintion:\n      @impl true\n      def filter_value(message) do\n        message[\"key\"]\n      end","ref":"RabbitMQStream.Producer.html#c:filter_value/1"},{"type":"callback","title":"RabbitMQStream.Producer.publish/1","doc":"Publishes a single message to the stream.\n\nThe message first passes through the 'encode!/1' callback, before\nbeing sent to the RabbitMQStream.Producer process responsible for\nsending the binary message to the Connection.\n\nAs of RabbitMQ 3.13.x, the mesagge's 'filter_value' is generated\nby passing it through the 'filter_value/1' callback.\n\nThe callback always returns ':ok', as the server only send a response\nfor a publish in case of an error, in which case the error code is logged.","ref":"RabbitMQStream.Producer.html#c:publish/1"},{"type":"function","title":"RabbitMQStream.Producer.start_link/1","doc":"","ref":"RabbitMQStream.Producer.html#start_link/1"},{"type":"type","title":"RabbitMQStream.Producer.option/0","doc":"","ref":"RabbitMQStream.Producer.html#t:option/0"},{"type":"type","title":"RabbitMQStream.Producer.options/0","doc":"","ref":"RabbitMQStream.Producer.html#t:options/0"},{"type":"type","title":"RabbitMQStream.Producer.t/0","doc":"","ref":"RabbitMQStream.Producer.html#t:t/0"},{"type":"module","title":"RabbitMQStream.SuperConsumer","doc":"A Superconsumer spawns a Consumer process for each partition of the stream.\n\nIt accepts the same options as a Consumer, plus the following:\n\n* `:super_stream` - the name of the super stream\n* `:partitions` - the number of partitions\n\n\nAll the consumers use the same provided connection, and are supervised by a\nDynamicSupervisor.","ref":"RabbitMQStream.SuperConsumer.html"},{"type":"type","title":"RabbitMQStream.SuperConsumer.super_consumer_option/0","doc":"","ref":"RabbitMQStream.SuperConsumer.html#t:super_consumer_option/0"},{"type":"type","title":"RabbitMQStream.SuperConsumer.t/0","doc":"","ref":"RabbitMQStream.SuperConsumer.html#t:t/0"},{"type":"behaviour","title":"RabbitMQStream.SuperProducer","doc":"A Superproducer spawns a Producer process for each partition of the stream,\nand uses the `routing_key/2` callback to forward a publish command to the\nproducer of the partition.\n\nIt accepts the same options as a Producer, plus the following:\n\n* `:super_stream` - the name of the super stream\n* `:partitions` - the number of partitions\n\nAll the producers use the same provided connection, and are supervised by a\nDynamicSupervisor.\n\nYou can optionally implement a `routing_key/2` callback to compute the target\npartition for a given message. By default, the partition is computed using\n`:erlang.phash2/2`.","ref":"RabbitMQStream.SuperProducer.html"},{"type":"behaviour","title":"Setup - RabbitMQStream.SuperProducer","doc":"To start a Superproducer, you need to make sure that each stream/partition\nis created beforehand. As of RabbitMQ 3.11.x and 3.12.x, this can only be done\nusing an [AMQP Client, RabbitMQ Management or with the RabbitMQ CLI.](https://www.rabbitmq.com/streams.html#super-streams).\n\nThe easiest way to do this is to use the RabbitMQ CLI:\n\n`$ rabbitmq-streams add_super_stream invoices --partitions 3`\n\nAs of RabbitMQ 3.13.x, you can also create a super stream using the\n`RabbitMQStream.Connection.create_super_stream/4`.","ref":"RabbitMQStream.SuperProducer.html#module-setup"},{"type":"callback","title":"RabbitMQStream.SuperProducer.routing_key/2","doc":"Callback responsible for generating the routing key for a given message and\npartitions size, which is then used to forward the publish request to the\nRabbitMQStream.Producer process responsible for the partition.","ref":"RabbitMQStream.SuperProducer.html#c:routing_key/2"},{"type":"type","title":"RabbitMQStream.SuperProducer.super_producer_option/0","doc":"","ref":"RabbitMQStream.SuperProducer.html#t:super_producer_option/0"},{"type":"type","title":"RabbitMQStream.SuperProducer.t/0","doc":"","ref":"RabbitMQStream.SuperProducer.html#t:t/0"},{"type":"behaviour","title":"RabbitMQStream.Consumer.OffsetTracking","doc":"Behavior for offset tracking strategies.\nIf you pass multiple strategies to the consumer, which will be executed in order, and\nand halt after the first one that returns a `:store` request.\n\n# Existing Strategies\nYou can use the default strategies by passing a shorthand alias:\n\n* `interval` : `RabbitMQStream.Consumer.OffsetTracking.IntervalStrategy`\n* `after` : `RabbitMQStream.Consumer.OffsetTracking.CountStrategy`","ref":"RabbitMQStream.Consumer.OffsetTracking.html"},{"type":"callback","title":"RabbitMQStream.Consumer.OffsetTracking.after_chunk/3","doc":"Optional Callback executed after every chunk, which can be used to update the state.\n\nUseful, for example, to store the offset after a certain number of messages.","ref":"RabbitMQStream.Consumer.OffsetTracking.html#c:after_chunk/3"},{"type":"callback","title":"RabbitMQStream.Consumer.OffsetTracking.init/1","doc":"Initializes the strategy state.\n\n# Parameters\n* `opts` - a keyword list of the options passed to the consumer,\n    merged with the options passed to the strategy itself.","ref":"RabbitMQStream.Consumer.OffsetTracking.html#c:init/1"},{"type":"callback","title":"RabbitMQStream.Consumer.OffsetTracking.run/2","doc":"Callback responsible for deciding whether to store the offset, based on its internal state.\n\n# Parameters\n\n* `state` - the state of the strategy\n* `subscription` - the state of the owner subscription process","ref":"RabbitMQStream.Consumer.OffsetTracking.html#c:run/2"},{"type":"type","title":"RabbitMQStream.Consumer.OffsetTracking.t/0","doc":"","ref":"RabbitMQStream.Consumer.OffsetTracking.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Consumer.OffsetTracking.CountStrategy","doc":"Count Strategy\n\nStores the offset after every `store_after` messages.\n\n# Usage\n    defmodule MyApp.MyConsumer do\n      alias RabbitMQStream.Consumer.OffsetTracking\n\n      use RabbitMQStream.Consumer,\n        offset_tracking: [OffsetTracking.CountStrategy, store_after: 50]\n\n      @impl true\n      def handle_chunk(_chunk, _subscriber) do\n        :ok\n      end\n    end\n\n\n# Parameters\n\n* `store_after` - the number of messages to receive before storing the offset","ref":"RabbitMQStream.Consumer.OffsetTracking.CountStrategy.html"},{"type":"module","title":"RabbitMQStream.Consumer.OffsetTracking.IntervalStrategy","doc":"Interval Strategy\n\nRuns a timer every `interval` milliseconds, and sends the parent process\na `:run_offset_tracking` message.\n\nSince we also execute the strategy after every message, we also reset any\ntimer that may be running when the strategy is returns a `:store`.\n\n\n# Usage\n    defmodule MyApp.MyConsumer do\n      alias RabbitMQStream.Consumer.OffsetTracking\n\n      use RabbitMQStream.Consumer,\n        offset_tracking: [OffsetTracking.IntervalStrategy, interval: 10_000]\n\n      @impl true\n      def handle_chunk(_chunk, _subscriber) do\n        :ok\n      end\n    end\n\n\n# Parameters\n\n* `interval` - the time in milliseconds before storing the offset","ref":"RabbitMQStream.Consumer.OffsetTracking.IntervalStrategy.html"},{"type":"behaviour","title":"RabbitMQStream.Consumer.FlowControl","doc":"Behavior for flow control strategies.\n\n# Existing Strategies\nYou can use the default strategies by passing a shorthand alias:\n\n* `count` : `RabbitMQStream.Consumer.FlowControl.MessageCount`","ref":"RabbitMQStream.Consumer.FlowControl.html"},{"type":"callback","title":"RabbitMQStream.Consumer.FlowControl.init/1","doc":"Initializes the strategy state.\n\n# Parameters\n* `opts` - a keyword list of the options passed to the consumer,\n    merged with the options passed to the strategy itself.","ref":"RabbitMQStream.Consumer.FlowControl.html#c:init/1"},{"type":"callback","title":"RabbitMQStream.Consumer.FlowControl.run/2","doc":"Callback responsible for deciding whether to add more credit, based on its internal state.\n\n# Parameters\n\n* `state` - the state of the strategy\n* `subscription` - the state of the owner subscription process","ref":"RabbitMQStream.Consumer.FlowControl.html#c:run/2"},{"type":"type","title":"RabbitMQStream.Consumer.FlowControl.t/0","doc":"","ref":"RabbitMQStream.Consumer.FlowControl.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Consumer.FlowControl.MessageCount","doc":"Message Count Strategy\n\nAdds credits after the amount of consumed credit reaches a certain threshold.\n\n# Usage\n    defmodule MyApp.MyConsumer do\n      alias RabbitMQStream.Consumer.FlowControl\n\n      use RabbitMQStream.Consumer,\n        offset_tracking: [FlowControl.MessageCount, credit_after: {:count, 1}]\n\n      @impl true\n      def handle_chunk(_chunk, _consumer) do\n        :ok\n      end\n    end\n\n# Parameters\n\n* `credit_after` - The type of computation performed to decide whether to add more credit.\n    Can be one of:\n    * `{:count, amount}` - adds the amount in credits after the specified is consumed\n    * `{:ratio, ratio}` - credits the missing amount after the ratio of remaining credits reaches the threshold\n\nDefaults to `{:count, 1}`.","ref":"RabbitMQStream.Consumer.FlowControl.MessageCount.html"},{"type":"extras","title":"Producing","doc":"# Producing\n\nThe RabbitMQ server expects us to declare a named producer, before being able to start publishing messages. You can declare a Producer Module as the following:\n\n```elixir\ndefmodule MyApp.MyProducer do\n  use RabbitMQStream.Producer,\n    stream_name: \"my-stream\"\nend\n```\n\nYou can publish a message to the stream by calling its `publish/1` callback with the binary contents of the message:\n  \n```elixir\nMyApp.MyProducer.publish(\"my-message\")\n```\n\nThe published messages are persisted by RabbitMQ Server as the raw binary you sent, wrapped inside a [Osiris Chunk](https://github.com/rabbitmq/osiris).","ref":"producing.html"},{"type":"extras","title":"Message De-duplication - Producing","doc":"By default it uses the module's name as the `:reference_name` passed to RabbitMQ. Internally the producer module keeps track of a `publishing_id` sequence, which is incremented after every message.\n\nThese two parameters are used by the RabbitMQ server to prevent message duplication. If it receives two messages from the same `reference_name` with the same `publishing_id`, it is ignored.","ref":"producing.html#message-de-duplication"},{"type":"extras","title":"Filter Value - Producing","doc":"As of RabbitMQ 3.13, you can provide a `filter_value` for each message, that are internally persisted alongside each message, and can be used to segment the consumption of messages. The filter values can then be provided when declaring a Consumer, so the server only sends chunks which that [might](https://blog.rabbitmq.com/posts/2023/10/stream-filtering/#on-the-consumer-side) contain messages which the consumer is interested in.\n\nThis might be useful when you that you will be processing only subsets of the messages of each stream, at a time, will already be doing some filtering at the client side, as it saves bandwidth by sending only the data\n\nWhen declaring a Producer/SuperProducer, you can optionally declare a `filter_value/1` callback that must return a `binary()` value that will be sent as the message's `filter_value`.\n\n```elixir\ndefmodule MyApp.MyProducer do\n  use RabbitMQStream.Producer,\n    stream_name: \"my-stream\"\n\n  @impl true\n  def filter_value(message) do\n    message[\"region\"]\n  end\nend\n```\n\nThen when consuming you can provide a `:filter` property to the Consumer/SuperConsumer as the following:\n\n```elixir\ndefmodule MyApp.MyConsumer do\n  use RabbitMQStream.Consumer,\n    initial_offset: :next,\n    stream_name: \"my-stream\",\n    properties: [\n      filter: [\"latam\", \"eu\"]\n    ]\n\n  @impl true\n  def handle_chunk(chunk, _) do\n    for message <- chunk.data_entries do\n      dbg(message)\n    end\n\n    :ok\n  end\nend\n```","ref":"producing.html#filter-value"},{"type":"extras","title":"Overview","doc":"# Overview\n\nRabbitMQ provides the necessary semantics to create allow for horizontally scaling the consumption from a Stream. It is built on top of two main concepts:\n\n- Single-Active-Consumer: A way to inform the server that for a specified stream, there can only be one active consumer with a specific name a time. See [Upgrade and Downgrade](#upgrade-and-downgrade).\n- Stream Partitions: A logical grouping of Stream.\n\nAs of 3.13.x, a SuperStream can be declare by using the `RabbitMQStream.Connection.create_super_stream/3` callback, but RabbitMQ Server 3.12.x and earlier requires you to manually declare it using the CLI. You can check more information on the [Stream Partitions](#stream-partitions) section bellow.","ref":"super-streams.html"},{"type":"extras","title":"Single Active Consumer - Overview","doc":"You can declare a consumer as being part of a Single Active Consumer group by passing the `:single_active_consumer` property, with the group's name, as follows:\n\n```elixir\ndefmodule Subs1 do\n  use RabbitMQStream.Consumer,\n    stream_name: \"super-stream-01\",\n    properties: [single_active_consumer: \"group-1\"]\n\n  @impl true\n  def handle_update(_, :upgrade) do\n    {:ok, :last}\n  end\n\n  @impl true\n  def handle_chunk(chunk, _state) do\n    dbg(chunk)\n\n    :ok\n  end\nend\n```\n\nThe server will then start sending chunks to the consumer, unless it decides it not to be the active one. If the Server decides to upgrade a consumer to being the active one, it goes through a [Upgrade process](#upgrade-and-downgrade).\n\n#","ref":"super-streams.html#single-active-consumer"},{"type":"extras","title":"Upgrade and Downgrade - Overview","doc":"When using `single-active-consumer` parameter, each consumer might go through `:upgrade` or `:downgrade` cycle. This happens when a new Consumer is chosen as the `active` one for a specific stream.\n\nTo handle upgrade and downgrade requests, a consumer must implement the `RabbitMQStream.Consumer.handle_update/2` callback. It receives the current state of the consumer, with the flag being either `:upgrade` or `:downgrade`.\n\nWhen a new consumer is chosen, the server first sends a `:consumer_update` request to the currently 'active' consumer with the flag set to `:downgrade`. You could take this moment to externally persist the consumer's current offset, either in the stream itself by calling `RabbitMQStream.Connection.store_offset/3`, or storing it externally. It waits for a response with the current consumer's offset before going forward with the upgrade, eventhough as of RabbiMQ 3.13, the server does not use this information.\n\nAfter the server receives the response from the current consumer, it sends a `:consumer_update` request with the `:upgrade` flag to the newly selected consumer. The now active consumer must return its desired offset to consume messages from.\n\n#","ref":"super-streams.html#upgrade-and-downgrade"},{"type":"extras","title":"Stream Partitions - Overview","doc":"A Super Stream partition a Stream that is a part of a SuperStream, and has a associated routing key. When producing messages using `RabbitMQStream.SuperProducer`, you must define the `c:RabbitMQStream.SuperProducer.partition/2` callback, that must map each message to its Partition, which is used by the manager to forward the message to the correct partition.\n\nAs of 3.12 and earlier, all partitions are automatically generated by the CLI. It can be done with the following command:\n\n`rabbitmq_stream rabbitmq-streams add_super_stream invoices --partitions 3`\n\nThe server then created a stream for each partition, with its name following the format: ` - `, where `N` is also the routing key for each message\n\nAs of 3.13.x, you can declare a SuperStream, alongside all its partitions with the `RabbitMQStream.Connection.create_super_stream/3` command, passing a custom name and routing key for each.","ref":"super-streams.html#stream-partitions"},{"type":"extras","title":"AMPQ Interop","doc":"# AMPQ Interop\n\nWhen using RabbitMQ, you are able to setup a queue as a Stream, and its messages can be consumed by any AMQP Client, or using the Streams Protocol. Using the [Elixir AMQP Client](https://github.com/pma/amqp), you can declare a hibrid queue as follows:\n\n```elixir\n{:ok, conn} = AMQP.Connection.open()\n{:ok, channel} = AMQP.Channel.open(conn)\n\n{:ok, _} =\n  AMQP.Queue.declare(\n    channel,\n    \"my-stream\",\n    durable: true,\n    arguments: [{\"x-queue-type\", \"stream\"}]\n  )\n\n:ok = AMQP.Exchange.declare(channel, \"my-exchange\")\nAMQP.Queue.bind(channel, \"my-stream\", \"my-exchange\")\n\n:ok = AMQP.Basic.publish(channel, \"my-exchange\", \"\", \"Hello, World!\")\n\n```\n\nThen any messages published to the queue are persited with `amqp1.0` binary format. You are able to decode the content of the message using the `:amqp10_framing.decode_bin/1` function of the [`:amqp_common`](https://hex.pm/packages/amqp10_common) library.\n\nYou can configure a Consumer Module to get only the content itself of each message by declaring the `decode!/1` callback.\n\n```elixir\ndefmodule MyApp.MyConsumer do\n  use RabbitMQStream.Consumer,\n    initial_offset: :next,\n    stream_name: \"my-stream\"\n  \n  @impl true\n  def decode!(message) do\n    :amqp10_framing.decode_bin(message)[:\"v1_0.data\"]\n  end\n\n  @impl true\n  def handle_chunk(%RabbitMQStream.OsirisChunk{}=chunk, _) do\n    for message <- chunk.data_entries do\n      dbg(message)\n    end\n\n    :ok\n  end\nend\n```\n\nYou can get more information on interop concepts on the related [Interoperability in RabbitMQ Streams](https://blog.rabbitmq.com/posts/2021/10/rabbitmq-streams-interoperability/) post.","ref":"interop.html"},{"type":"extras","title":"Offset","doc":"# Offset\n\nWhen consuming from a Stream, you might be interested in consuming all the messages all the way from the beggining, the end, or somewhere in between. Wehn we start consuming from a stream, we tell RabbitMQ where we want to start consuming from, which is called the `offset`.\n\nWhen starting to consume from a stream, we have some options for the offset:\n\n<!-- :first | :last | :next | {:offset, non_neg_integer()} | {:timestamp, integer()} -->\n\n* `:first` - Consume all the messages from the stream, starting from the beggining.\n* `:last` - Consume the last message in the stream at the moment the consumer starts, and all the messages that are published after that.\n* `:next` - Consume only the messages that are published after the consumer starts.\n* `{:offset, non_neg_integer()}` - Consume all the messages from the stream, starting from the offset provided. Each chunk's offset is present in its metadata.\n* `{:timestamp, integer()}` - Consume all the messages from the stream, starting from the message that was published at the timestamp provided.","ref":"offset.html"},{"type":"extras","title":"Example - Offset","doc":"When calling the `RabbitMQStream.Connection.subscribe/5` callback, we can provide the `:offset` option:\n\n```elixir\ndefmodule MyApp.MyConnection\n  use RabbitMQStream.Connection\nend\n\n{:ok, _} = MyApp.MyConnection.start_link()\n\n\n{:ok, subcription_id} = RabbitMQStream.Connection.subscribe(\n  \"stream-name-01\",\n  self(),\n  :first,\n  50_000,\n  []\n)\n```\n\nOr you can provide the `:initial_offset` option to `RabbitMQStream.Consumer`:\n\n```elixir\ndefmodule MyApp.MyConsumer do\n  use RabbitMQStream.Consumer,\n    connection: MyApp.MyConnection,\n    stream_name: \"my_stream\",\n    offset_reference: \"default\", # defaults to the module's name. E.g. MyApp.MyConsumer\n    initial_offset: :first\n\n  @impl true\n  def handle_chunk(%RabbitMQStream.OsirisChunk{} = _chunk, _consumer) do\n    :ok\n  end\nend\n```","ref":"offset.html#example"},{"type":"extras","title":"Offset Tracking - Offset","doc":"Altough the RabbitMQ server doesn't automatically tracks the offset of each consumer, it provides a `store_offset` command. This allows us to store a piece of information, the `offset`, which is referenced by a `reference_name`, on the stream itself. We can then use it to retreive the offset later on, when starting the Consumer.\n\nA `RabbitMQStream.Consumer` instance automatically queries the offset under `reference_name` on startup, and uses it as the offset passed to the subscribe command. It automatically stores the offset based on customizeable strategies.\n\nBy default it uses the `RabbitMQStream.Consumer.OffsetTracking.CountStrategy` strategy, storing the offset whenever `count` messages are received. It can be used with:\n\n```elixir\nalias RabbitMQStream.Consumer.OffsetTracking.CountStrategy\n\nuse RabbitMQStream.Consumer,\n  stream_name: \"my_stream\",\n  offset_tracking: [CountStrategy, store_after: 50]\n  # ...\n\n# The macro also accepts a simplified alias `count`\nuse RabbitMQStream.Consumer,\n  stream_name: \"my_stream\",\n  offset_tracking: [count: [store_after: 50]]\n\n# You can also declare multiple strategies to run concurrently.\nuse RabbitMQStream.Consumer,\n  stream_name: \"my_stream\",\n  offset_tracking: [\n    count: [store_after: 50],\n    interval: [interval: 10_000] # RabbitMQStream.Consumer.OffsetTracking.IntervalStrategy\n  ]\n```\n\nYou can also implement you own strategy by implementing the `RabbitMQStream.Consumer.OffsetTracking` behavior, and passing it to the `offset_tracking` option.","ref":"offset.html#offset-tracking"},{"type":"extras","title":"Getting Started","doc":"# Getting Started","ref":"getting-started.html"},{"type":"extras","title":"Installation - Getting Started","doc":"First add RabbitMQ to your `mix.exs` dependencies:\n\n```elixir\ndef deps do\n  [\n    {:rabbitmq_stream, \"~> 0.4.0\"},\n    # ...\n  ]\nend\n```","ref":"getting-started.html#installation"},{"type":"extras","title":"Consuming from stream - Getting Started","doc":"First you define a connection\n\n```elixir\ndefmodule MyApp.MyConnection\n  use RabbitMQStream.Connection\nend\n```\n\nYou can configure the connection in your `config.exs` file:\n\n```elixir\nconfig :rabbitmq_stream, MyApp.MyConnection,\n  vhost: \"/\"\n```\n\nManually starting the connection is as simple as:\n\n```elixir\n{:ok, _} = MyApp.MyConnection.start_link()\n```\n\nThen you can consume to messages from a stream with:\n\n```elixir\n{:ok, _subscription_id} = MyApp.MyConnection.subscribe(\"stream-01\", self(), :next, 999)\n```\n\nWhich will the start sending the caller process messages containg chunks from the stream, with the format `{:deliver, %RabbitMQStream.Message.Types.DeliverData{} = deliver_data}`, which you can handle with, for example, in your `handle_info/2` callback on your GenServer module:\n\n```elixir\ndef handle_info({:deliver, %RabbitMQStream.Message.Types.DeliverData{} = deliver_data}, state) do\n  # do something with message\n  {:noreply, state}\nend\n```\n\nYou can also define a Consumer module that subscribes to a stream, and keeps track of its credits and offset.\n\n```elixir\ndefmodule MyApp.MyConsumer do\n  use RabbitMQStream.Consumer,\n    connection: MyApp.MyConnection,\n    stream_name: \"my_stream\",\n    initial_offset: :first\n\n  @impl true\n  def handle_chunk(%RabbitMQStream.OsirisChunk{} = _chunk, _consumer) do\n    :ok\n  end\nend\n```\n\nJust add it to your supervision tree, and it will start consuming from the stream.\n\n```elixir\nchildren = [\n  MyApp.MyConnection,\n  MyApp.MyConsumer\n  # ...\n]\n```","ref":"getting-started.html#consuming-from-stream"},{"type":"extras","title":"Publishing to stream - Getting Started","doc":"To prevent message duplication, RabbitMQ requires us to declare a named Producer before being able to publish messages to a stream. We can do this by `using` the `RabbitMQStream.Producer`, which declare itself to the Connection, with the specified `:reference_name`, defaulting to the module's name.\n\n```elixir\ndefmodule MyApp.MyProducer\n  use RabbitMQStream.Producer,\n    stream_name: \"my_stream\",\n    connection: MyApp.MyConnection\nend\n```\n\nThen you can publish messages to the stream with:\n\n```elixir\nMyApp.MyProducer.publish(\"Hello World\")\n```","ref":"getting-started.html#publishing-to-stream"},{"type":"extras","title":"Configuration","doc":"# Configuration\n\nThis library currently implements the following actors:\n\n- `RabbitMQStream.Connection`: Manages a single TCP/SSL connection to a single RabbitMQ Stream node.\n- `RabbitMQStream.Consumer`: Consumes from a single stream, while tracking its offset and credits. Requires an existing `RabbitMQStream.Connection`.\n- `RabbitMQStream.Producer`: Manages a single producer to a single stream. Requires an existing `RabbitMQStream.Connection`.","ref":"configuration.html"},{"type":"extras","title":"Configuration Merging - Configuration","doc":"We can provide the configuration at many different levels, that will then be merged together. The order of precedence is:\n\n#","ref":"configuration.html#configuration-merging"},{"type":"extras","title":"1. Defaults - Configuration","doc":"At your `config/*.exs` file, you can provide a default configuration that will be passed to all the instances of each of the actors. But some of these options are ignored as they don't really make sense to be set at the default level. For example, the `:stream_name` option is ignored by the `Producer` actor. You can see which options are ignored in the documentation of each actor.\n\nYou can provide the default configuration like this:\n\n```elixir\nconfig :rabbitmq_stream, :defaults,\n  connection: [\n    vhost: \"/\",\n    # RabbitMQStream.Connection.connection_option()\n    # ...\n  ],\n  consumer: [\n    connection: MyApp.MyConnection,\n    # [RabbitMQStream.Consumer.consumer_option()]\n    # ...\n  ],\n  producer: [\n    connection: MyApp.MyConnection,\n    # [RabbitMQStream.Producer.producer_option()]\n    # ...\n  ]\n```\n\n#","ref":"configuration.html#1-defaults"},{"type":"extras","title":"2. Module specific configuration - Configuration","doc":"Each time you implement an instance of the actor, with `use RabbitMQStream.Connection`, for example, you can define its configuration on your config file.\n\nFor example, if we have the following module:\n\n```elixir\ndefmodule MyApp.MyConnection\n  use RabbitMQStream.Connection\nend\n```\n\nWe can define its configuration like this:\n\n```elixir\nconfig :rabbitmq_stream, MyApp.MyConnection,\n  vhost: \"/\"\n```\n\n#","ref":"configuration.html#2-module-specific-configuration"},{"type":"extras","title":"3. When defining the actor - Configuration","doc":"When defining the actor, you can provide the configuration as an option to the `use` macro:\n\n```elixir\ndefmodule MyApp.MyConnection\n  use RabbitMQStream.Connection,\n    vhost: \"/\"\nend\n```\n\n#","ref":"configuration.html#3-when-defining-the-actor"},{"type":"extras","title":"4. When starting the actor - Configuration","doc":"When manually starting the actor, you can provide the configuration as an option to the `start_link` function:\n\n```elixir\n{:ok, _} = MyApp.MyConnection.start_link(vhost: \"/\")\n```\n\nOr pass the options when defining it in your supervision tree:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_, _) do\n    children = [\n      {MyApp.MyConnection, vhost: \"/\"},\n      # ...\n    ]\n\n    opts = # ...\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\nFor more information, you can check the documentation at each actor's module;","ref":"configuration.html#4-when-starting-the-actor"},{"type":"extras","title":"Global Options - Configuration","doc":"#","ref":"configuration.html#global-options"},{"type":"extras","title":"Serializer - Configuration","doc":"You can define a Serializer module to be used by the Producer and Consumer modules. It is expected to implement `encode!/1` and `decode!/1` callbacks, and must be defined at compile-time level configurations.","ref":"configuration.html#serializer"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.4.0 - Changelog","doc":"Added support for RabbitMQ 3.13, with Route, Partitions and SuperStreams support.\n\n#","ref":"changelog.html#0-4-0"},{"type":"extras","title":"0.4.0 Features - Changelog","doc":"- Support for `:consumerupdate`, `:exchangecommandversions`, `:streamstats`,  commands.\n- Serialization options for encoding and decoding messages.\n- TLS Support\n- Functional `single-active-consumer`.\n- Initial support for `filter_value` consumer parameter, and `:createsuperstream`, `:deletesuperstream`, `:route`, `:partitions` commands.\n- Initial support for SuperStreams, with RabbitMQStream.SuperConsumer and RabbitMQStream.SuperPublisher.\n\n#","ref":"changelog.html#0-4-0-features"},{"type":"extras","title":"0.4.0 Changes - Changelog","doc":"The 'Message' module tree was refactored to make all the Encoding and Decoding logic stay close to each other.\n\n- Improved the cleanup logic for closing the connection.\n- Publishers and Consumers now expects any name of a GenServer process, instead of a Module.\n- Added checks on supported commands based on Server version, and exchanged commands versions.\n\n#","ref":"changelog.html#0-4-0-changes"},{"type":"extras","title":"0.4.0 Breaking Changes - Changelog","doc":"- Renamed `RabbitMQStream.Subscriber` to `RabbitMQStream.Consumer`\n- Renamed `RabbitMQStream.Publisher` to `RabbitMQStream.Producer`\n- Each Deliver action made by the connection is now done with a `{:deliver, %RabbitMQStream.Message.Types.DeliverData{}} tuple\n- Offset Tracking now prefers to use CommitedOffset when available","ref":"changelog.html#0-4-0-breaking-changes"},{"type":"extras","title":"0.3.0 - Changelog","doc":"Added an implementation for a stream Consumer, fixed bugs and improved the documentation.\n\n#","ref":"changelog.html#0-3-0"},{"type":"extras","title":"0.3.0 Features - Changelog","doc":"- Added the `:credit` command.\n- Added `RabbitMQStream.Subscriber`, which subscribes to a stream, while tracking its offset and credit based on customizeable strategies.\n- Added the possibility of globally configuring the default Connection for Publishers and Subscribers\n\n#","ref":"changelog.html#0-3-0-features"},{"type":"extras","title":"0.3.0 Bug Fixes - Changelog","doc":"- Fixed an issue where tcp packages with multiple commands where not being correctly parsed, and in reversed order\n\n#","ref":"changelog.html#0-3-0-bug-fixes"},{"type":"extras","title":"0.3.0 Changes - Changelog","doc":"- `RabbitMQStream.Publisher` no longer calls `connect` on the Connection during its setup.\n- Moved `RabbitMQStream.Publisher`'s setup logic into `handle_continue`, to prevent locking up the application startup.\n- `RabbitMQStream.Publisher` no longer declares the stream if it doesn't exists.\n- `RabbitMQStream.Publisher` module now can optionally declare a `before_start/2` callback, which is called before it calls `declare_publisher/2`, and can be used to create the stream if it doesn't exists.\n- `RabbitMQStream.Connection` now buffers the requests while the connection is not yet `:open`.\n\n#","ref":"changelog.html#0-3-0-changes"},{"type":"extras","title":"0.3.0 Breaking Changes - Changelog","doc":"- Subscription deliver messages are now in the format `{:chunk, %RabbitMQ.OsirisChunk{}}`.","ref":"changelog.html#0-3-0-breaking-changes"},{"type":"extras","title":"0.2.1 - Changelog","doc":"Documentation and Configuration refactoring\n\n- It is now possible to define the connection and subscriber parameters throught the `config.exs` file\n- Documentation improvements, and examples","ref":"changelog.html#0-2-1"},{"type":"extras","title":"0.2.0 - Changelog","doc":"The main objective of this release is to remove the manually added code from `rabbitmq_stream_common`'s Erlang implementation of Encoding and Decoding logic, with frame buffering.","ref":"changelog.html#0-2-0"},{"type":"extras","title":"0.1.0 - Changelog","doc":"Initial release with the following features:\n\n- Opening connection to RabbitMQ server\n- Declaring a Stream\n- Creating a Stream Publisher\n- Subscribing to Stream Messages\n- Initial Hex Release","ref":"changelog.html#0-1-0"}],"content_type":"text/markdown"}